
/*

  netclipd_main.c -- main entry point for netclipd
  Copyright (C) 2017  Charlie Sale

  This file is part of netclip

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <netclip.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

// global variables
clip_stack_t *root_stack; // this is the stack for the clippings
// int clip_max_size; // max size for clip stack

/* TODO: add some commandline options */

netclip_sock_t server; // the server socket description

int main(int argc, char **argv)
{
  // for process
  pid_t pid = fork(); // for into a new process

  /* First, start the server */
  server = netclip_serv_init (8899); // start server on port 8899
  if (server == -1)
    {
      printf("ACK\n");
      return -1;
    }

  /* Next, accept clients and handle their request */
  int conn;
  struct sockaddr_storage conn_addr;
  socklen_t addr_size = sizeof conn_addr;
  while (conn = accept(server, (struct sockaddr*)&conn_addr, &addr_size))
    {
      char *request = malloc (8);
      char *buffer = malloc (512);
      buffer = netclip_net_recv(conn, request); // read some data

      if (!strcmp(request, NCR_CREAT))
        {
          // handle create
        }
      else if (!strcmp(request, NCR_READ))
        {
          // handle read
        }
      else if (!strcmp(request, NCR_GET))
        {
          // handle get
        }
      else if(!strcmp(request, "kill"))
        {
          break; // kill daemon
        }
      else
        {
          printf("[netclipd %d]: invalid command\n", pid);
          return -1;
        }
    }

  return 0;
}
